import os
import tempfile

TENANT_BASE = tempfile.mkdtemp('hobo-tenant-base')
TENANT_MODEL = 'multitenant.Tenant'
MIDDLEWARE = ('hobo.multitenant.middleware.TenantMiddleware',) + MIDDLEWARE
BRANCH_NAME = os.environ.get("BRANCH_NAME", "").replace('/', '_').replace('-', '_').encode('ascii', 'ignore').decode()
DATABASES = {
	'default': {
		'ENGINE': 'tenant_schemas.postgresql_backend',
        'TEST': {'NAME': ('hobo_test_schemas_' + BRANCH_NAME)[:63]},
	}
}
DATABASE_ROUTERS = ('tenant_schemas.routers.TenantSyncRouter',)
INSTALLED_APPS = ('hobo.multitenant', 'hobo') + INSTALLED_APPS
SHARED_APPS = ()
TENANT_APPS = INSTALLED_APPS
PROJECT_NAME = 'testing'
